<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");
require_once(__DIR__."/login_check.php");


$page_title="Customize Notifications";
$page_message="Customize server notifications displayed to users during license check. All variables surrounded by % sign will be automatically converted into real values in your script.<br><br>For more information on supported variables, refer to the Help section.";
$page_message_class="alert alert-info";
$page_header_file_no_data="index.php";


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


$notification_id=1; //manually set notification_id because no other ids should be available


if (!empty($_POST) && is_array($_POST) && array_walk($_POST, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all POST values
    {
    extract($_POST, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (empty($notification_id) || !filter_var($notification_id, FILTER_VALIDATE_INT) || empty($rows_array=fetchRow("SELECT * FROM apl_notifications WHERE notification_id=?", array($notification_id), array("i")))) //invalid record
    {
    header("Location: $page_header_file_no_data");
    exit();
    }


if (!isset($submit_ok)) //extract fetched variables only if form wasn't submitted (otherwise data entered by user will be overwritten with data from database in case of form submission failure)
    {
    foreach ($rows_array as $row)
        {
        extract($row);
        }
    }


if (isset($submit_ok))
    {
    if (!empty($notification_license_ok) && !empty($notification_license_not_found) && !empty($notification_invalid_ip) && !empty($notification_invalid_domain) && !empty($notification_domain_required) && !empty($notification_domain_in_use) && !empty($notification_license_suspended) && !empty($notification_license_expired) && !empty($notification_updates_expired) && !empty($notification_support_expired) && !empty($notification_license_cancelled) && !empty($notification_license_limit) && !empty($notification_installation_not_found) && !empty($notification_invalid_signature) && !empty($notification_host_banned) && !empty($notification_unknown_error))
        {
        if ($error_detected!=1)
            {
            $updated_records=updateRow("UPDATE apl_notifications SET notification_license_ok=?, notification_license_not_found=?, notification_invalid_ip=?, notification_invalid_domain=?, notification_domain_required=?, notification_domain_in_use=?, notification_license_suspended=?, notification_license_expired=?, notification_updates_expired=?, notification_support_expired=?, notification_license_cancelled=?, notification_license_limit=?, notification_installation_not_found=?, notification_invalid_signature=?, notification_host_banned=?, notification_unknown_error=?", array($notification_license_ok, $notification_license_not_found, $notification_invalid_ip, $notification_invalid_domain, $notification_domain_required, $notification_domain_in_use, $notification_license_suspended, $notification_license_expired, $notification_updates_expired, $notification_support_expired, $notification_license_cancelled, $notification_license_limit, $notification_installation_not_found, $notification_invalid_signature, $notification_host_banned, $notification_unknown_error), array("s", "s", "s", "s", "s", "s", "s", "s", "s", "s", "s", "s", "s", "s", "s", "s"));
            if ($updated_records<1)
                {
                $error_detected=1;
                $error_details.="Invalid record details or duplicated record (no new data).<br>";
                }
            else
                {
                $action_success=1;
                }
            }
        }
    else
        {
        $error_detected=1;
        $error_details.="Invalid notification(s).<br>";
        }

    if ($action_success==1) //everything OK
        {
        $page_message="Server notifications updated.";
        createReport(strip_tags($page_message), $logged_admin_id, 1, $error_detected);
        $page_message_class="alert alert-success";
        }
    else //display error message
        {
        $page_message="The database could not be updated because of this error: <br><br>$error_details";
        $page_message_class="alert alert-danger";
        }
    }


//Twig templating starts
if (!isset($script_filename)) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);} //if $script_filename is not set yet (usually set in login_check.php), get it now (will be used in Twig forms)

Twig_Autoloader::register();
$loader=new Twig_Loader_Filesystem("../apl_templates"); //load files from templates directory
$twig=new Twig_Environment($loader); //create Twig environment

$twig->addExtension(new \nochso\HtmlCompressTwig\Extension());

echo $twig->render(basename(__DIR__)."/".basename(__FILE__, ".php").".twig", get_defined_vars()); //render requested template
//Twig templating ends
