<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");
require_once(__DIR__."/login_check.php");


$page_title="Database Search";
$page_message="Search database for records matching your search criteria. Only record types that have matches will be displayed. The limit of search results is $RECORDS_ON_SEARCH_PAGE for each type of records.";
$page_message_class="alert alert-info";
$page_header_file_no_data="index.php";


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


if (!empty($_GET) && is_array($_GET) && array_walk($_GET, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all GET values
    {
    extract($_GET, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (empty($search_keyword)) //no search term submitted
    {
    header("Location: $page_header_file_no_data");
    exit();
    }


if (isset($submit_ok))
    {
    if (strlen(trim($search_keyword))>2)
        {
        $action_success=1;

        $products_array=returnProductsArray($search_keyword, $RECORDS_ON_SEARCH_PAGE);
        $clients_array=returnClientsArray($search_keyword, $RECORDS_ON_SEARCH_PAGE);
        $licenses_array=returnLicensesArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
        $installations_array=returnInstallationsArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
        $callbacks_array=returnCallbacksArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
        $license_reports_array=returnLicenseReportsArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
        }
    else
        {
        $error_detected=1;
        $error_details.="Invalid search term (3 characters minimum).<br>";
        }

    if ($action_success==1) //everything OK
        {
        $page_message="Database search for term $search_keyword performed. The limit of search results is $RECORDS_ON_SEARCH_PAGE for each type of records.";
        createReport(strip_tags($page_message), $logged_admin_id, 1, $error_detected);
        $page_message_class="alert alert-success";
        }
    else //display error message
        {
        $page_message="The search could not be performed because of this error: <br><br>$error_details";
        $page_message_class="alert alert-danger";
        }
    }


//Twig templating starts
if (!isset($script_filename)) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);} //if $script_filename is not set yet (usually set in login_check.php), get it now (will be used in Twig forms)

Twig_Autoloader::register();
$loader=new Twig_Loader_Filesystem("../apl_templates"); //load files from templates directory
$twig=new Twig_Environment($loader); //create Twig environment

$twig->addExtension(new \nochso\HtmlCompressTwig\Extension());

echo $twig->render(basename(__DIR__)."/".basename(__FILE__, ".php").".twig", get_defined_vars()); //render requested template
//Twig templating ends
