<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");


if (isset($_SERVER['REMOTE_ADDR'])) {$ip_address=$_SERVER['REMOTE_ADDR'];}
if (isset($_SERVER['HTTP_REFERER'])) {$refer=$_SERVER['HTTP_REFERER'];}
if (isset($_SERVER['REQUEST_URI'])) {$requested_page=$_SERVER['REQUEST_URI'];}
if (isset($_SERVER['SCRIPT_FILENAME'])) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);}
if (isset($_SERVER['HTTP_USER_AGENT'])) {$user_agent=$_SERVER['HTTP_USER_AGENT'];}


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


$api_action_success=0;
$api_error_detected=0;
$api_error_details=null;
$logged_admin_id=null; //used for compatibility with createReport function in the same file in /apl_admin directory. since admin is not logged in when API is called, $logged_admin_id must be null


if (!empty($_POST) && is_array($_POST) && array_walk($_POST, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all POST values
    {
    extract($_POST, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (!empty($api_key_secret) && !empty($api_function) && $api_post_key==hash("sha256", $ROOT_URL) && $submit_ok=="Submit" && $refer=="$ROOT_URL/apl_api/api.php" && in_array($user_agent, $SUPPORTED_BROWSERS_ARRAY)) //prevent someone from posting to this file directly
    {
    if ($API_STATUS==1 && in_array($api_function, $SUPPORTED_API_FUNCTIONS_ARRAY))
        {
        $api_key_rows_array=fetchRow("SELECT * FROM apl_api_keys WHERE api_key_secret=? AND api_key_status=?", array($api_key_secret, 1), array("s", "i"));
        if (empty($api_key_rows_array))
            {
            $api_error_detected=1;
            $api_error_details.="Invalid or inactive API key.<br>";
            }
        else
            {
            foreach ($api_key_rows_array as $api_key_row)
                {
                extract($api_key_row);
                }

            if (!empty($api_key_ip))
                {
                $api_key_ip_array=explode(",", $api_key_ip);
                if (!in_array($ip_address, $api_key_ip_array))
                    {
                    $api_error_detected=1;
                    $api_error_details.="Invalid IP address.<br>";
                    }
                }

            $api_permissions_name="api_key_".$api_function; //since each permission in database starts with api_key_ prefix, add this prefix to name of function submitted by user for quick permissions check
            if ($$api_permissions_name!=1)
                {
                $api_error_detected=1;
                $api_error_details.="Invalid API key permissions.<br>";
                }

            if ($api_error_detected!=1 && $$api_permissions_name==1)
                {
                $api_action_success=1;
                }
            }
        }
    else
        {
        $api_error_detected=1;
        $api_error_details.="API not enabled or invalid API function.<br>";
        }

    if ($api_action_success==1) //everything OK
        {
        if (isset($submit_ok))
            {
            if (!empty($search_keyword) && in_array($search_type, $SUPPORTED_API_SEARCHES_ARRAY))
                {
                if ($error_detected!=1)
                    {
                    if ($search_type=="callback")
                        {
                        $rows_array=returnCallbacksArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
                        }

                    if ($search_type=="client")
                        {
                        $rows_array=returnClientsArray($search_keyword, $RECORDS_ON_SEARCH_PAGE);
                        }

                    if ($search_type=="installation")
                        {
                        $rows_array=returnInstallationsArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
                        }

                    if ($search_type=="license")
                        {
                        $rows_array=returnLicensesArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
                        }

                    if ($search_type=="product")
                        {
                        $rows_array=returnProductsArray($search_keyword, $RECORDS_ON_SEARCH_PAGE);
                        }

                    if ($search_type=="report")
                        {
                        $rows_array=returnLicenseReportsArray(null, $search_keyword, $RECORDS_ON_SEARCH_PAGE);
                        }
                    }
                }
            else
                {
                $error_detected=1;
                $error_details.="Invalid search type or keyword.<br>";
                }

            if ($error_detected!=1)
                {
                if (empty($rows_array))
                    {
                    $error_details.="No results found.";
                    }
                else
                    {
                    $action_success=1;
                    }
                }

            if ($action_success==1) //everything OK
                {
                $page_message=$rows_array;
                }
            else //display error message
                {
                $page_message=array("error"=>"The results could not be displayed because of this error: <br><br>$error_details");
                }
            }
        }
    else //display error message
        {
        $page_message=array("error"=>"The action could not be completed because of this error:<br><br>$api_error_details");
        }


    echo json_encode($page_message);
    }
